  
  #-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------#
  #
  ##############################################################
  ####      Function to Generate Angles among Locations     ####
  ##############################################################
  ####    version 1.0 Created by Chong Liu on 2012/10/30    ####
  ##############################################################
  #
  #-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------#                                              
  # Input:
  #-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------#
  # 1.Coordinate:  Cartesian coordinates of locations
  # 2.Type:        Type of angle computed. 
  #                Type = 1, angles are from -90 to 90, vectors symmetric about the origin are assigend angles (except for 90 and -90, need adjustment outside the function)
  #                Type = 2, angles are from -180 to 180, vectors in the lower half of the plane are assigned negtive angles
  #                Type = 3, angles are from 0 to 360 which are 360 + Type 2
  # 3.Replace:     Value assinged to angle between a location and itself
  #-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------#
  # Output
  #-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------#
  # 1.AngleMat:    The angle matrix, computed as the angle from x-axis to the difference vector between two locations. 
  #-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------#


		AngleGen <- function(Coordinate, Type = 1, Replace = 0)
		{
      # load packages and functions 
      
			  #source("UF.RepMat.r")
		
      # Compute angles
			
        coordinate.x <- as.matrix(Coordinate[,1])
        coordinate.y <- as.matrix(Coordinate[,2])
        N <- length(coordinate.x)
        dist.x <- RepMat(t(coordinate.x),N,1) - RepMat(coordinate.x,1,N) 
        dist.y <- RepMat(t(coordinate.y),N,1) - RepMat(coordinate.y,1,N)        
        if(Type == 1){AngleMat <- atan(dist.y/dist.x) * 180 / pi;AngleMat[is.nan(AngleMat)] <- Replace} # fisrt type of angles between -90 and 90        
        if(Type == 2) {AngleMat <- atan2(dist.y, dist.x) * 180 / pi} # second type of angles between -180 and 180 # AngleMat[AngleMat < -90] <- AngleMat[AngleMat < -90] + 180; AngleMat[AngleMat > 90] <- AngleMat[AngleMat > 90] - 180 # transform the second type to the first type
        if(Type == 3){AngleMat <- atan2(dist.y, dist.x) * 180 / pi + 360} # third type of angles between 0 and 360
        
      # return angle matrix
        
        return(AngleMat)
		}