  
  #-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------#
  #
  ####################################################################
  ####    Function to Reconstruct Curve from SPACE EstimateList   ####
  ####################################################################
  #
  #-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------#                                              
  # Input:
  #-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------#
  #
  #-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------#
  # Output
  #-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------#
  #
  #-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------#
  
  ReConstructWrap <- function(Par, Coordinate, K, Rotate, EstimateList, Independent)
  {
    DataMat <- EstimateList$DataMat      
    TimeIndex <- EstimateList$TimeIndex
    FitMu.Regular <- EstimateList$FitMu.Eval
    EigenFun <- EstimateList$SmoothList$EigenFunEst
    NumCurves <- dim(Coordinate)[1]
    Omega <- array(NA, dim = c(NumCurves, NumCurves, K))
    for(k in 1 : K)
    {
      Omega[,,k] <- AnisoMatern(Coordinate = Coordinate, Alpha = Par[k,1], Delta = Par[k,2], Kappa = Par[k,3], Phi = Par[k,4], Log = c(0,0,0,0))
    }
    Lambda <- EstimateList$SmoothList$LambdaEst
    if(Rotate)
    {
      Sigma <- EstimateList$SigmaEst.Rotate
    }else
    {
      Sigma <- EstimateList$SigmaEst.UnRotate
    }
    FitMu <- EstimateList$SmoothList$FitMu
    FitMu.Regular <- EstimateList$SmoothList$FitMu.Eval
    ReconstructionList <- ReConstruct(DataMat = DataMat, TimeIndex = TimeIndex, FitMu = FitMu, EigenFun = EigenFun, Omega = Omega, Lambda = Lambda, 
                                      Sigma = Sigma, FitMu.Regular = FitMu.Regular, Independent = Independent)
    return(ReconstructionList)
  }
      
  
  
  